﻿using UnityEngine;
using System.Collections;

public class CameraTransitionBehaviour : MonoBehaviour {

    public Camera cameraA;
    public Camera cameraB;

    public Vector4[] rects;

    [Range(0f, 1f)]
    public float state = 0f;

    void LateUpdate()
    {
        Vector4 vA = Vector4.Lerp(rects[0], rects[1], state);
        Rect rectA = new Rect(vA.x, vA.y, vA.z, vA.w);

        Vector4 vB = Vector4.Lerp(rects[2], rects[3], state);
        Rect rectB = new Rect(vB.x, vB.y, vB.z, vB.w);

        if (rectA.width <= 0 || rectA.height <= 0)
            cameraA.enabled = false;
        else if (!cameraA.enabled)
            cameraA.enabled = true;

        cameraA.rect = rectA;

        if (rectB.width <= 0 || rectB.height <= 0)
            cameraB.enabled = false;
        else if (!cameraB.enabled)
            cameraB.enabled = true;

        cameraB.rect = rectB;
    }
}
